;*****************************************************************************************
;  Infra-Read
;  Detects Infra-red signals by showing green streaks and noise
;  To Test: align TV Remote with IR port on top of Game Boy and press button on Remote
;
;  It will detect any IR signal, even found one coming from a Nightlight, and it had a constant
;  frequency! COOOOOL!
;
;  All Code by -Pan- of Anthrox  (C) 1999
;  Use as You wish, modify if You want
;  For more cool, unique gags and gadgets for GameBoy visit:
;  http://www.jps.net/paninaro
;  http://www.anthrox.com
;*****************************************************************************************

    ;******************************************************************
    ;                            Header Equates
    ;******************************************************************
;Cartridge type:
; 0 - Rom only      3 - ROM+MBC1+RAM+Battery  1 - ROM+MBC1      5 - ROM+MBC2
; 2 - ROM+MBC1+RAM  6 - ROM+MBC2+Battery
CARTTYPE  EQU 2
;Rom Size:
; 0 - 256kBit =  32kB =  2 banks ; 1 - 512kBit =  64kB =  4 banks
; 2 -   1MBit = 128kB =  8 banks ; 3 -   2MBit = 256kB = 16 banks
; 4 -   4MBit = 512kB = 32 banks
ROMSIZE   EQU 0
;Ram Size:
; 0 - None ; 1 -  16kBit =  2kB = 1 bank
; 3 - 256kBit = 32kB = 4 banks
RAMSIZE   EQU 3
;Manufacturer code (word):
MANUCODE  EQU 1
;Version Number (byte):
VERSION   EQU 1

;************************************************************************************
;     Do NOT modify unless you are familiar with header info *Modified for Game Boy Color*
;************************************************************************************

SECTION "Header",home[$0100]
  ;Jumper
  nop
  jp Start ; go to Start of program:
  ;Nintendo Scrolling Title Graphic
  DB $CE,$ED,$66,$66,$CC,$0D,$00,$0B,$03,$73,$00,$83,$00,$0C,$00,$0D
  DB $00,$08,$11,$1F,$88,$89,$00,$0E,$DC,$CC,$6E,$E6,$DD,$DD,$D9,$99
  DB $BB,$BB,$67,$63,$6E,$0E,$EC,$CC,$DD,$DC,$99,$9F,$BB,$B9,$33,$3E
  ;Title of the game
  db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128 ; Filled in by RGBFIX
  ;Not used
  db 0,0,0; last should be 3, won't work in emu unles it's 0
  ;Cartridge type:
  db CARTTYPE
  ;Rom Size:
  db ROMSIZE
  ;Ram Size:
  db RAMSIZE
  ;Manufacturer code:
  db 00, $33
  ;Version Number
  db VERSION
  ;Complement check
  db $0a
  ;Checksum
  dw 0





  ;*********************************************************************
  ;              This is the Infra-Read detection program
  ;*********************************************************************

 ;SECTION "Main", home

Start:

  ld a, $c0      ;set infrared port to READ
  ldio [$56],a
 
   
 
  
  
 
  
megaloop:
  ldio a,[$56]
  and 2          ; 0 means detected, 1 means nothing found
  jp nz, dored   ; if nothing found then set color to RED
dogreen:
  ld a,$80
  ldio [$68],a
  ld a,$e0        ; Infrared signal detected! Display Green Color
  ldio [$69],a
  ld a,$3
  ldio [$69],a


  ld a,$ff
  ldio [$24],a
  
  ld a,$0
  ldio [$24], a    ; Sound off (When turning on and off it will create noise)
  
 
  
  jp megaloop   ; go back and test again

dored:
  ld a,$80
  ldio [$68],a
  ld a,$1f        ; No infrared signal detected. Display Red Color
  ldio [$69],a
  ld a,$0
  ldio [$69],a
  jp megaloop   ; go back and test again



